'******************************
'*  VGA 640 x 480 x 8bpp-lut  *
'******************************

CON

  intensity     = 80    '0..128

  fclk          = 80_000_000.0
  fpix          = 80_000_000.0 '74_250_000.0'80_000_000.0
  fset          = (fpix / fclk * 2.0) * float($4000_0000)

  vsync         =       0       'vsync pin (all FPGA boards now)

DAT             org
'
'
' Setup
'
                rdfast  #0,##$1000-$400         'load .bmp palette into lut
                rep     @.end,#$100
                rflong  y
                shl     y,#8
                wrlut   y,x
                add     x,#1
.end


'reorder bits
                mov     t,##$1000-254*4
                rep     @ReorderDone,##1920*1080/8/2
                rdbyte  y,t
                rev     x,y
                ror     x,#24
                wrbyte  x,t
                add     t,#1
ReorderDone

                rdfast  ##1920*1080/64/8/2,##$1000-254*4 'adjust for 1bpp palette    'set rdfast to wrap on bitmap

                setxfrq ##$8000_0000'round(fset)'$8000_0000'round(fset)           'set transfer frequency to 25MHz

                setb    dira+vsync>>5,#vsync    'make vsync pin output

                'the next 4 lines may be commented out to bypass level scaling

                setcy   ##intensity << 24       'r      set colorspace for rgb
                setci   ##intensity << 16       'g
                setcq   ##intensity << 08       'b
                setcmod #%01_0_000_0            'enable colorspace conversion

                pinsetm dacmode,#0              'enable dac modes in pins 0..3
                pinsetm dacmode,#1
                pinsetm dacmode,#2
                pinsetm dacmode,#3
'
'
' Field loop
'
field           mov     x,#36'33                   'top blanks
                call    #blank

                mov     x,##1080'480                  'set visible lines
line            call    #hsync                  'do horizontal sync
                xcont   m_rf,#0                 'visible line
                djnz    x,#line                 'another line?

                mov     x,#4'10                   'bottom blanks
                call    #blank

                notb    outa+vsync>>5,#vsync    'sync on

                mov     x,#5'2                    'sync blanks
                call    #blank

                notb    outa+vsync>>5,#vsync    'sync off

                jmp     #field                  'loop
'
'
' Subroutines
'
blank           call    #hsync                  'blank lines
                xcont   m_vi,#0
                djnz    x,#blank
                ret

hsync           xcont   m_bs,#0                 'horizontal sync
                xcont   m_sn,#1
                xcont   m_bv,#0
                ret
'
'
' Initialized data
'
dacmode         long    %101<<29 + %10100<<8

m_bs            long    $CF000000+88/2'16            'before sync
m_sn            long    $CF000000+44/2'96            'sync
m_bv            long    $CF000000+148/2'48            'before visible
m_vi            long    $CF000000+1920/2'640           'visible

m_rf            long    $4F000000+1920/2'640 '1bpp $7F000000+640           'visible rlong 8bpp lut

x               res     1
y               res     1

t               res     1  

'
' Bitmap
'
                orgh    $1000 - $436    'justify pixels at $1000, pallete at $1000-$400
                file    "bmp2_1080p60_1bpp.bmp"'bitmap2_mono.bmp"   '640 x 480, 8pbb-lut